# encoding: utf-8
require "logstash/agent"
require "logstash/universal_plugin"

module Fuzzy
  class WaynesWorldCore < LogStash::UniversalPlugin
    include LogStash::Util::Loggable

    class AgentListener
      include LogStash::Util::Loggable

      def initialize
        logger.error("initialize")
      end

      def after_initialize(agent)
        settings = LogStash::Settings.clone
        settings.set("dynamic_reloading")

        agent.register_pipeline...
        logger.error("after_initialize", :happy_wayneworld_port => LogStash::SETTINGS.get("happy.wayneworld.port"))
      end
    end

    def initialize
      logger.error("initialize universal plugin")
    end

    def register_hooks(hooks)
      logger.error("register_hooks")
      hooks.register_hooks(LogStash::Agent, AgentListener.new)
    end

    def additionals_settings(settings)
      logger.error("additionals_settings")
      settings.register(LogStash::Setting::PortRange.new("happy.wayneworld.port", 9600..9700))
    end
  end
end
